import ij.*;
import ij.process.*;
import ij.gui.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Vector;

import ij.io.*;
import ij.plugin.filter.*;

import java.awt.geom.*;
import java.util.*;
import ij.plugin.*;
import ij.measure.*;

/**
 * plugin destin a la slction graphique du centre
 *
 * @author gilles courbatieu
 *
 */
public class Center_Graphical implements PlugInFilter,MouseListener {
	ImagePlus imp;
	GenericDialog gd;//boite de dialogue standard
	ImageWindow IWin;//window de l'image
	ImageCanvas ICan;//canvas de l'image
	ImageProcessor IPro;//processeur associer a l'image
	FileInfo ImpInfo;//infromation sur l'image
	Line lineax,lineay;
	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_ALL;
	}

	public void run(ImageProcessor ip) {
//		on initialise les differantes variable
		IWin=imp.getWindow();
		ICan=IWin.getCanvas();
		IPro=ip;
//		slction du centre
		ICan.addMouseListener(this);
		GUI();
	}
	/************************************************************************
	 * reaction au click permettant la selection du centre
	 ************************************************************************/
	public void mouseClicked(MouseEvent e)
		{
			int x = ICan.offScreenX(e.getX());
			int y = ICan.offScreenY(e.getY());
			Point Pt =new Point(x,y);
			choice(Pt);
		}
	/************************************************************************
	 * non utilis
	 ************************************************************************/
	public void mousePressed(MouseEvent e)
		{
//		not use
		}
	/************************************************************************
	 * non utilis
	 ************************************************************************/
	public void mouseExited(MouseEvent e)
		{
//		not use
		}
	/************************************************************************
	 * non utilis
	 ************************************************************************/
	public void mouseEntered(MouseEvent e)
		{
//		not use
		}
	/************************************************************************
	 * non utilis
	************************************************************************/
	public void mouseReleased(MouseEvent e)
		{
//		not use
		}
	/************************************************************************
	 * procedure de debut du plugin
	 *
	 ************************************************************************/
	void GUI()
		{
			gd = new GenericDialog("Graphical selection of center");
			gd.addMessage("Click on center");
			gd.showDialog();
		}
	/************************************************************************
	 * procedure de confirmation du point choisie
	 * @param P point choisie
	 ************************************************************************/
	void choice(Point P)
	{
		drawCroix(P.x,P.y);
		//IJ.showMessage("cration russie !");
		//double Rx=ImpInfo.pixelWidth,Ry=ImpInfo.pixelHeight;//recuperation des dimension des pixel
		//gd = new GenericDialog("Graphical selection of center");
		//gd.addMessage("le point selectionn est x="+P.x+", y="+P.y+"");
		//gd.showDialog();
		//if(!gd.wasCanceled())
		//{
		IJ.setColumnHeadings("X center\tY center");
		IJ.write(""+P.x+"\t"+P.y);
		//save(P);
		Prefs.set("user.centerx",P.x);
		Prefs.set("user.centery",P.y);
		Prefs.savePreferences();
		suppr();
		//	}
		//drawCroix(P.x,P.y);

	}
	/************************************************************************
	 * fonction de trac du centre par une croix
	 * X , Y coordonnes du centre
	 ************************************************************************/
	public void drawCroix(int X, int Y)
	{
		//double Rx=ImpInfo.pixelWidth,Ry=ImpInfo.pixelHeight;//recuperation des dimension des pixel
		GeneralPath path = new GeneralPath();
		float x;
		float y;
		//calcul des coordonnes
		x=(float)(X);///Rx);
		y=(float)(Y);///Ry);
		// -------- affiche une croix
		//IPro.reset();//reinitialisation de l'image
		int width = imp.getWidth();
		int height = imp.getHeight();
		//IJ.showMessage("dessin russi!"+width+" "+height);
		/*lineax=new Line((int)(x),1,(int)(x),height);
		lineay=new Line(1,(int)(y),width,(int)(y));
		IPro.setLineWidth(1);
		IPro.setValue(IPro.getMax()*2);
		IPro.drawLine(lineax.x1, lineax.y1, lineax.x2, lineax.y2);
		IPro.drawLine(lineay.x1, lineay.y1, lineay.x2, lineay.y2);
		imp.updateAndDraw();*/
		path.moveTo(x, 1);
		path.lineTo(x, height);
		path.moveTo(1, y);
		path.lineTo(width, y);
		ImageCanvas ic = imp.getCanvas();
		if (ic==null) return;
		if (path==null)
			ic.setDisplayList(null);
		else
			ic.setDisplayList(path, Color.red, null);
	}


	/************************************************************************
	 * fonction sauvant les information utile
	 * @param P centre a sauvegard
	 * @return vrai si reussit faux sinon
	 ************************************************************************/
	/*synchronized boolean  save(Point centre){
//		objet permetant l'ecriture dans un fichier
		FileWriter fileW;
		FileReader fileR;
		File Fic;
//		on recuper le nom de l'image ouverte
		FileInfo Fi=imp.getOriginalFileInfo();
		String imgName=Fi.fileName;

		final String ROI_TITLE="ROI";//titre de champ
		final String CENTER_TITLE="CENTER";//titre de champ
		final char LINE_SEPARATOR='\n';//caractre separant les ligne
		final char IMG_SEPARATOR='#';//caractre separant les le nom de l'image
		final char FIELD_SEPARATOR='?';//caractre separant les champs
		final char SUBFIELD_SERARATOR=':';//caratre separant les attribut des champs
		final String Path=IJ.getDirectory("startup")+"Save.txt";//chemins du fichier de sauvegard
		int nbChar,subFieldCounter=0;//nombre de caractre du fichier, compteur de champ lors de la lecture
		int alreadySave=-1;//a la valeur de l'index dans readBuf si l'image est deja prsant dans le fichier sinon -1

		//variable utilisaer aussi bien en lecture qu'en ecriture
		Vector Buf=new Vector();//vecteur stockant l'ensblem de ligne du fichier
		String[] Line=new String[6];//tabeau stockant l'ensemble des champ composant une ligne
		String text="";//chaine stockant les valeur des champ

		Fic=new File(Path);//on verifie s'il existe sinon on le cre
		if(!Fic.exists())
			{
				IJ.error("Fichier de sauvegarde absent !!");
				try
					{
						Fic.createNewFile();
					}
				catch(Exception e)
					{
						IJ.error("Problme de cration du fichier");
						return false;
					}
				//IJ.showMessage("cration russie !");
			}
		nbChar=(int)Fic.length();//on recupere le nombre de caractre deja presant dansle fichier, eventuelement 0
		try
			{
				fileR=new FileReader(Fic);
				char c;
				for(int i=0;i<nbChar;i++)//extraction du contenu du fichier de sauvergarde
					{
						c=(char)fileR.read();
//						si on recontre un caractre de separation de champ ou de sous-champ on ajout le string au tableau
						if(c==IMG_SEPARATOR || c==SUBFIELD_SERARATOR || c==FIELD_SEPARATOR)
							{
								Line[subFieldCounter]=text;
								text="";
								subFieldCounter++;
							}
						else if(c==LINE_SEPARATOR)
							{//si on rencontre un caractre de fin de ligne on ajout le sting au tableau puis le tableau au vecteur
								Line[subFieldCounter]=text;
								text="";
								subFieldCounter=0;
								Buf.add(Line);
								Line=new String[6];
							}
							else//sinon on ajout le caractre au string
								{
									text+=c;
								}
					}
				for(int i=0;i<Buf.size();i++)
					{//on regard si l'image est deja presant
						if(imgName.equals(((String[])Buf.elementAt(i))[0]))
							{
								alreadySave=i;
							}
					}

				//on ajout a la fin ou on remplce selon le cas les info de l'image
				if(alreadySave==-1)
					{
						Line=new String[6];
						Line[0]=imgName;
						Line[1]=CENTER_TITLE;
						Line[2]=""+centre.x;
						Line[3]=""+centre.y;
						Line[4]=ROI_TITLE;
						Line[5]="null";
						Buf.add(Line);
					}
				else
					{
						Line=(String[])Buf.elementAt(alreadySave);
						Line[2]=""+centre.x;
						Line[3]=""+centre.y;
						Buf.setElementAt(Line,alreadySave);
					}

				//on actualise le fichier en entier
				fileW=new FileWriter(Fic);
				Fic.delete();
				Fic.createNewFile();
				for(int i=0;i<Buf.size();i++)
					{
						Line=(String[])Buf.elementAt(i);
						text=Line[0]+IMG_SEPARATOR
								+Line[1]+SUBFIELD_SERARATOR+Line[2]+SUBFIELD_SERARATOR+Line[3]+FIELD_SEPARATOR
								+Line[4]+SUBFIELD_SERARATOR+Line[5]+LINE_SEPARATOR;
						fileW.write(text.toCharArray());
						text="";
					}
				fileW.flush();
				fileW.close();
				fileR.close();
			}
		catch(Exception e)
			{
			IJ.log(e.toString());
			for(int i=0;i<(e.getStackTrace()).length;i++){
				IJ.log((e.getStackTrace()[i]).toString());
			}
				return false;
			}
		return true;
	}*/
	/************************************************************************
	 * procedure de suppresion de l'ensemble de attribut.
	 ************************************************************************/
	private void suppr(){
		ICan.removeMouseListener(this);
		imp=null;
		IWin=null;
		ICan=null;
		gd=null;
		IPro=null;
		System.gc();
	}
}
