import ij.*;
import ij.process.*;
import ij.gui.*;

import java.awt.*;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Vector;

import ij.plugin.filter.*;
import ij.io.*;

/**
 * plugin destin a trouve les centre de maniere automatique grace a la valeur maximal des pixels.
 * 
 * @author gilles courbatieu
 *
 */
public class Maximum_ implements PlugInFilter {
	ImageWindow IWin;//window de l'image
	ImageCanvas ICan;//canvas de l'image
	ImagePlus imp;
	
	GenericDialog gd;//boite de dialogue standard
	Point centre;//centre
	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_16+DOES_32+DOES_8G;
	}
	public void run(ImageProcessor ip) {
		IJ.write("Processing...");
		IWin=imp.getWindow();
		ICan=IWin.getCanvas();
		MaxProcess(ip);
	}
	/************************************************************************
	 * procedure effectuant le traitement proprement dit
	 * @param IPro ncessaire au traitement
	 ************************************************************************/
	 void MaxProcess(ImageProcessor IPro)
		{
		 	PointRoi cRoi;
			double imgMin=IPro.getMin(),imgMax=IPro.getMax();// on memorise la max/min actuel 
			IPro.resetMinAndMax();//on rest pour obtenir le bon maximum(si on avait eventuelement modifier les Max/Min de l'image)
			double Max=IPro.getMax(); //on trouve la valuation maximal detenu par l'imageProcessor
			int Good=0,x=0,y=0,Y=0,X=0;
				while(Good==0&& x<IPro.getWidth()){//on recherche le point possedant cette valuation
					for(y=0;y<imp.getHeight();y++){
						if(IPro.getf(x,y)==Max){Good=1;Y=y;X=x;}
					}
					x++;
				}
			IPro.setMinAndMax(imgMin, imgMax);
			IJ.showMessage("Maximum trouv au point x:"+X+" y:"+Y+" Valeur:"+Max);
			centre =new Point(X,Y);
			
//			on affiche les centre trouv
			cRoi=new PointRoi(X,Y);
			imp.setRoi(cRoi);
			imp.updateAndRepaintWindow();
			
			saveCentre();
			suppr();
		}
	 /************************************************************************
	 * fonction se chargeant de la sauvegard du centre
	 * @return string de retour du loading de preferance
	 ************************************************************************/
	synchronized boolean  saveCentre(){
//		objet permetant l'ecriture dans un fichier
		FileWriter fileW;
		FileReader fileR;
		File Fic;
//		on recuper le nom de l'image ouverte
		FileInfo Fi=imp.getOriginalFileInfo();
		String imgName=Fi.fileName;
		
		final String ROI_TITLE="ROI";//titre de champ
		final String CENTER_TITLE="CENTER";//titre de champ
		final char LINE_SEPARATOR='\n';//caractre separant les ligne
		final char IMG_SEPARATOR='#';//caractre separant les le nom de l'image
		final char FIELD_SEPARATOR='?';//caractre separant les champs
		final char SUBFIELD_SERARATOR=':';//caratre separant les attribut des champs
		final String Path=IJ.getDirectory("startup")+"Save.txt";//chemins du fichier de sauvegard
		int nbChar,subFieldCounter=0;//nombre de caractre du fichier, compteur de champ lors de la lecture
		int alreadySave=-1;//a la valeur de l'index dans readBuf si l'image est deja prsant dans le fichier sinon -1
		
		//variable utilisaer aussi bien en lecture qu'en ecriture
		Vector Buf=new Vector();//vecteur stockant l'ensblem de ligne du fichier
		String[] Line=new String[6];//tabeau stockant l'ensemble des champ composant une ligne
		String text="";//chaine stockant les valeur des champ
		
		Fic=new File(Path);//on verifie s'il existe sinon on le cre
		if(!Fic.exists())
			{
				IJ.error("Fichier de sauvegard absent !!");
				try
					{
						Fic.createNewFile();
					}
				catch(Exception e)
					{
						IJ.error("Probleme de creation du fichier");
						return false;
					}
				IJ.showMessage("cration russit !");
			}
		nbChar=(int)Fic.length();//on recupere le nombre de caractre deja presant dansle fichier, eventuelement 0
		try
			{
				fileR=new FileReader(Fic);
				char c;
				for(int i=0;i<nbChar;i++)//extraction du contenu du fichier de sauvergarde
					{
						c=(char)fileR.read();
//						si on recontre un caractre de separation de champ ou de sous-champ on ajout le string au tableau
						if(c==IMG_SEPARATOR || c==SUBFIELD_SERARATOR || c==FIELD_SEPARATOR)
							{
								Line[subFieldCounter]=text;
								text="";
								subFieldCounter++;
							}
						else if(c==LINE_SEPARATOR)
							{//si on rencontre un caractre de fin de ligne on ajout le sting au tableau puis le tableau au vecteur
								Line[subFieldCounter]=text;
								text="";
								subFieldCounter=0;
								Buf.add(Line);
								Line=new String[6];
							}
							else//sinon on ajout le caractre au string
								{
									text+=c;
								}
					}
				for(int i=0;i<Buf.size();i++)
					{//on regard si l'image est deja presant
						if(imgName.equals(((String[])Buf.elementAt(i))[0]))
							{
								alreadySave=i;
							}
					}
				
				//on ajout a la fin ou on remplce selon le cas les info de l'image
				if(alreadySave==-1)
					{
						Line=new String[6];
						Line[0]=imgName;
						Line[1]=CENTER_TITLE;
						Line[2]=""+centre.x;
						Line[3]=""+centre.y;
						Line[4]=ROI_TITLE;
						Line[5]="null";
						Buf.add(Line);
					}
				else
					{
						Line=(String[])Buf.elementAt(alreadySave);
						Line[2]=""+centre.x;
						Line[3]=""+centre.y;
						Buf.setElementAt(Line,alreadySave);
					}
				
				//on actualise le fichier en entier
				fileW=new FileWriter(Fic);
				Fic.delete();
				Fic.createNewFile();
				for(int i=0;i<Buf.size();i++)
					{
						Line=(String[])Buf.elementAt(i);
						text=Line[0]+IMG_SEPARATOR
								+Line[1]+SUBFIELD_SERARATOR+Line[2]+SUBFIELD_SERARATOR+Line[3]+FIELD_SEPARATOR
								+Line[4]+SUBFIELD_SERARATOR+Line[5]+LINE_SEPARATOR;
						fileW.write(text.toCharArray());
						text="";
					}
				fileW.flush();
				fileW.close();
				fileR.close();
			}
		catch(Exception e)
			{
			IJ.log(e.toString());
			for(int i=0;i<(e.getStackTrace()).length;i++){
				IJ.log((e.getStackTrace()[i]).toString());
			}
				return false;
			}
		return true;
	}
	/************************************************************************
	 * procedure supprimant les attribut de l'objet pour librre la memoire
	 ************************************************************************/
	private void suppr(){
		imp=null;
		gd=null;
    	System.gc();
	}
}
