import ij.*;
import ij.process.*;
import ij.gui.*;
//import ij.io.DirectoryChooser;
//import ij.io.FileInfo;
import ij.io.*;
import java.awt.*;
import java.awt.geom.GeneralPath;
import java.math.*;
import java.util.*;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Vector;
import java.util.Iterator;

import ij.plugin.filter.*;
import ij.plugin.frame.RoiManager;
/**
 * plugin qui effectue les traitemetn de regroupement radial mais avec plusieur modalit�
 *  comme une echelle en "Q" et non en pixel, plus la possiblite de misa a l'echelle.
 * @author gilles courbatieu
 *
 */
public class New_Image_With_Geometrical_Correction_interpolation implements PlugInFilter {
	ImagePlus imp;
	ImageProcessor IPro;
	GenericDialog gd;//boite de dialogue standard
	Point Centre,CentreScale;///cente de l'image
	int imgH,imgW;//respectivement hauteur et largeur de l'image
	float L,qMax;//D: distence ehcantillion/detecteur,qMax: valeur max de "q" definie par l'utilisateur
	double lambda,pixelSize;//L: longueur d'onde,a: dimension d'un pixel
	double alpha_deg, alpha_rad;
	float qSecteur;//pas en q
	int qDiv,DisMax;//qDiv: decoupe de qMax,DisMax: distance max de coin par rappot au centre
	double[] qValue;// valeur en q des diffrent secteur
	double[] averageValue;//somme des valeurs par secteur
	float tolerance;
	double [] values; // sum of values after removing high pixels
	double [] deviation; // array of deviation
	double tempoValue;
	int[] nbPts;//nombre de point par secteur
	int removed;//nb of removed points
	float[] qTab;
	Roi selectRoi,defaultRoi;
	FileInfo Fi;//info de l'image
	String OutputPath,RoiPath;//chemin de sortie des donn�es, et chemin du masque
	String RoiFile;//roi file name
	RoiManager roiMan;
	double prCent=0.0; //pour le progressBar
	double prCent2=0; //pour le progressBar
	double e=1,alpha=0;//coef de decalage en x et y
	boolean scaled=false;//vrai s'il y a une mise a l'echelle a faire sinon faux
	boolean qcalcul=true;
	int new_pixelSize_Factor=1;
	

	public int setup(String arg, ImagePlus imp) {
		if(imp==null){
			IJ.noImage();
			return DONE;
		}
		this.imp = imp;
//		initialisation de variable
		imgH=imp.getHeight();
		imgW=imp.getWidth();
		Centre=new Point(0,0);
		CentreScale=new Point(0,0);
		defaultRoi=new Roi(0,0,imgW,imgH);
		return DOES_16+DOES_32+DOES_8G;
	}

	public void run(ImageProcessor ip) {
		ip.snapshot();
		IPro=ip;
		ImageProcessor ipmask;
		//on recupere les info de l'image
		Fi= imp.getOriginalFileInfo();
		//on recupere les roi manager
		roiMan =(RoiManager)WindowManager.getFrame("ROI Manager");
		if(roiMan==null) roiMan =new RoiManager();
		else{
			roiMan.close();
			roiMan = new RoiManager();
		}
				
		if (!getParameters())// on demande les parametres a l'utilisateur
			{
			CleanUp();
			return;
		}
		
		
		Rectangle maskBounds; //bounds of mask
		int xMask,yMask;//x and y coordinate of the rectangle mark
		
//				
//		
		int ind=0;
		
		
		//--------- -----------
		Date today = new Date();
		long start = today.getTime(); // beginning time
		//IJ.log(""+start);
		// test sur la roi
		ipmask=selectRoi.getMask();
		if (ipmask==null) {
	        IJ.error("Problem with ROI (Non-rectangular selection required ?)");
	        return;
		}
		maskBounds=selectRoi.getBounds();
		xMask=maskBounds.x;
		yMask=maskBounds.y;
		
		GeneralPath path = new GeneralPath();
		IPro.reset();//reinitialisation de l'image
		//int imgW = imp.getWidth();
		//int imgH = imp.getHeight();
		path.moveTo(Centre.x, 1);
		path.lineTo(Centre.x, imgH);
		path.moveTo(1, Centre.y);
		path.lineTo(imgW, Centre.y);
		ImageCanvas ic = imp.getCanvas();
		if (ic==null) return;
		if (path==null)
			ic.setDisplayList(null);
		else
			ic.setDisplayList(path, Color.red, null);
		
//		 ------ init arrays
		int new_width, new_height;
		new_width=imgW/new_pixelSize_Factor;
		new_height=imgH/new_pixelSize_Factor;
		float[][] pixels=new float[new_width][new_height];
		int[][] nbpixels=new int [new_width][new_height];
		for (int i=0; i<new_width; i++)
			for (int j=0; j<new_height; j++)
				{
				pixels[i][j] = 0;
				nbpixels[i][j] = 0;
				}
		
		
		
		double[] tabXY=new double[2];
		double new_distance=0;
		double q;
		double dx=0; // x pixel -xC
		double dy=0; // y pixel -yC
		double cos_theta;
		double theta;
		double new_xc=0;
		int new_x=0;
		int new_y=0;
		double new_dy=0;
		double new_dx=0;
		int new_xindice=0;
		int new_yindice=0;
		removed=0;
		int test;
		IJ.showProgress(0.0);
		IJ.showStatus("Image correction...");
		test=0;
		double cosPI_alpharad;
		double y=0;
		double x=0;
		double d;
		cosPI_alpharad=Math.cos(Math.PI-alpha_rad);
		double sin_alpharad=Math.sin(alpha_rad);
		double cos_alpharad=Math.cos(alpha_rad);
		for(new_x=0;new_x<imgW;new_x++){
			for(new_y=0;new_y<imgH;new_y++){
				//d=distance(x,y,Centre.x,Centre.y);
				//theta=Math.atan(d*pixelSize/(L));
				new_dx=(new_x-Centre.x)*pixelSize;
				new_dy=(new_y-Centre.y)*pixelSize;
				
				dx=(L*new_dx)/(L*sin_alpharad-new_dx*cos_alpharad);
				dy=new_dy*(1+(new_dx*cos_alpharad/(L*sin_alpharad-new_dx*cos_alpharad)));
				
				y=dy/pixelSize+Centre.y;
				x=dx/pixelSize+Centre.x;
				
				if ((x>=0)&&(x<imgW)&&(y>=0)&&(y<imgH))
						pixels[new_x][new_y]=(float)ip.getInterpolatedPixel(x,y);
				if ((new_x==1000)&&(new_y==1000)){
					IJ.log("x:"+x+"  y:"+y+"   centre x:"+Centre.x+"   centre y:"+Centre.y+"  new_xc:"+new_xc);
					//IJ.log("pixelsize : "+pixelSize+"  L"+L+"    new_dx :"+new_dx+"  new_x:"+new_x);
					IJ.log("new_x:"+new_x+"  new_y:"+new_y+"    new_dx :"+new_dx+"    new_dy :"+new_dy+"  pixel value : "+pixels[new_x][new_y]);
				}
				
			}//y
			prCent=(double)(new_x)/(double)(imgW);
			IJ.showProgress(prCent);
			
						
		}//x
		//IJ.log("division");
		/*for(int x=0;x<new_width;x++){
			for( y=0;y<new_height;y++){
				if (nbpixels[x][y]>0)
					pixels[x][y]=pixels[x][y]/nbpixels[x][y];
			}
			prCent=(double)(x)/(double)(imgW);
			IJ.showProgress(prCent);
		}*/
		IJ.showProgress(1.1);
		IJ.showStatus("");
		IJ.showTime(imp,start,"Elapsed time : ");
		ImageProcessor ip_output = new FloatProcessor(pixels);
		ImagePlus imp = new ImagePlus("Image corrected with alpha "+alpha_deg, ip_output);
		imp.show();
		CleanUp();//on libere la memoire
		
		

	}

	/************************************************************************
	 * fonction qui calcule la distance entre 2 point en l'arrondissant a l'entier inferieur
	 * @param x coordnn�es du 1er point
	 * @param y coordnn�es du 1er point
	 * @param x2 coordnn�es du 2eme point
	 * @param y2 coordnn�es du 2eme point
	 * @return entier representant la distance entre les 2 point
	 *************************************************************************/
	double distance(double x,double y,double x2,double y2){
		double X=0,Y=0,res=0;
		Y=Math.pow((y-y2),2);
		X=Math.pow((x-x2),2);
		res=Math.sqrt(X+Y);
		return res;
	}
	

	
	/************************************************************************
	 * Parameters GUI
	 * @return true if ok, False if canceled
	 ************************************************************************/
	boolean getParameters(){
		OpenDialog ODRoiFile;
		DirectoryChooser ODOutputPath;
	
		//extract pixel size
		pixelSize=Fi.pixelHeight;
		if(pixelSize<0){
			IJ.error("Error, pixel size is incorrect !!");
			return false;
		}

		Double convertor= new Double(0);//convertisseur de flotant sous forme de <String> en entier sous forme de <double>
		MathContext mc= new MathContext(2);//precision
		BigDecimal virgule=new BigDecimal(0);//premet de gere le nombre de decimal d'un flotant
		gd = new GenericDialog("Parameters...");
		
		String[] TabPathRoi={Prefs.get("user.ROI","null"),"other"};
		String[] TabPathOutput={Prefs.get("user.Output.path","null"),"other"};
		
		pixelSize=Prefs.get("user.PixelSize",1.0);
		//lambda=Prefs.get("user.wavelength",1.542);
		L=(float)Prefs.get("user.DetectorDistance",1.0);
		qDiv=(int)Prefs.get("user.QDiv",512);
		//e=(float)Prefs.get("user.e",1);
		Centre.x=(int)Prefs.get("user.centerx",1);
		Centre.y=(int)Prefs.get("user.centery",1);
		//qMax=(float)Prefs.get("user.qmax",1.0);
		//qcalcul=(boolean)Prefs.get("user.typeofcalcul",true);
		//String[] typeChoice={"q","pixel"};
		alpha_deg=(double)Prefs.get("user.alpha_deg",90.0);
			
		
		tolerance=-1;
		//IJ.log("distancemax:"+DisMax);
		//double tmpQ=(((4*Math.PI)/L)*((DisMax*a)/(2*D)));
		// DIALOG construction --------------------------------
		gd.addChoice("ROI :",TabPathRoi,TabPathRoi[0]);
		gd.addChoice("Output path :",TabPathOutput,TabPathOutput[0]);
		gd.addNumericField("Center x : ",Centre.x,0);
		gd.addNumericField("Center y : ",Centre.y,0);
		//gd.addNumericField("scaling x/y : ",e,4);
		//gd.addNumericField("Wavelength ("+IJ.angstromSymbol+") : ",lambda,5);
		gd.addNumericField("Detector distance (cm) : ",L,5);
		gd.addNumericField("Pixel size (cm) : ",pixelSize,4);
		gd.addNumericField("alpha (deg) : ",alpha_deg,5);
		//gd.addMessage("calculated qmax="+tmpQ);
		//gd.addNumericField("Qmax or pixel max : ",qMax,4);
		gd.addNumericField("New pixelsize factor : ",new_pixelSize_Factor,4);
		
		int choice=0;
		//if (!qcalcul) choice=1;
		//gd.addChoice("Type of averaging :",typeChoice,typeChoice[choice]);
		//gd.addNumericField("Tolerance for hot pixels (%)",tolerance,4);
		gd.showDialog();
		
		// End of dialog --------------------------------
		if(gd.wasCanceled()){
			return false;
		}
		//	get parameters
		RoiFile=gd.getNextChoice();
		if (RoiFile=="other")
		{
			//ask for ROI
			ODRoiFile=new OpenDialog("Select ROI file","");
			RoiFile=ODRoiFile.getDirectory()+ODRoiFile.getFileName();
			if (RoiFile==null) {
				IJ.error("No ROI File selected.");
				return false;	
			}
			
		}
		Prefs.set("user.ROI",RoiFile);
		roiMan.runCommand("Open",RoiFile);
		roiMan.select(0);
		selectRoi=imp.getRoi();
		if (selectRoi==null) IJ.error("error on loading ROI");
		
		OutputPath=gd.getNextChoice();
		if (OutputPath=="other")
		{
			//ask for output path
			ODOutputPath=new DirectoryChooser("Select output path");
			OutputPath=ODOutputPath.getDirectory();
			if (OutputPath==null)
				{
				IJ.error("No output path selected.");
				return false;	
				}
			
			
		}
		Prefs.set("user.Output.path",OutputPath);
		
		Centre.x=(int)gd.getNextNumber();
		Centre.y=(int)gd.getNextNumber();
		//e=gd.getNextNumber();
		//lambda=gd.getNextNumber();
		//if(lambda<=0)return getParameters();

		L=(float)gd.getNextNumber();
		if(L<=0)return getParameters();

		pixelSize=(float)gd.getNextNumber();
		if(pixelSize<=0)return getParameters();
		
		alpha_deg=(double)gd.getNextNumber();
		if(alpha_deg<=0)return getParameters();
		alpha_rad=alpha_deg*2*Math.PI/360.0;
		

		//qMax=(float)gd.getNextNumber();
		//if(L<=0)return getParameters();

		new_pixelSize_Factor=(int)gd.getNextNumber();
		if(new_pixelSize_Factor<=0)return getParameters();
		
		/*String typeOfCalcul=gd.getNextChoice();
		qcalcul=(typeOfCalcul=="q");
		tolerance=(float)gd.getNextNumber();

		//on sauve les parametres entr�s
		Prefs.set("user.wavelength",lambda);
		Prefs.set("user.DetectorDistance",L);
		Prefs.set("user.Qmax",qMax);
		Prefs.set("user.QDiv",qDiv);
		Prefs.set("user.PixelSize",pixelSize);
		Prefs.set("user.e",e);
		Prefs.set("user.centerx",Centre.x);
		Prefs.set("user.centery",Centre.y);
		Prefs.set("user.qmax",qMax);
		Prefs.set("user.typeofcalcul",qcalcul);
		Prefs.set("user.alpha_deg", alpha_deg);
		Prefs.savePreferences();
		*/

		return true;
	}
	
	
	/************************************************************************
	 * procedure supprimant les attribu de l'objet pour libr�re la memoire
	 ************************************************************************/
	void CleanUp(){
		imp=null;
		gd=null;
		Centre=null;
		qValue=null;
		averageValue=null;
		nbPts=null;
		
		selectRoi=null;
		defaultRoi=null;
		Fi=null;
		OutputPath=null;
		roiMan=null;
    	System.gc();
	}
}
