
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
 

import ij.*;

import java.io.File;
import ij.io.*;
import ij.plugin.PlugIn;

/**
 * 
 * @author Olivier Tache'  CEA Saclay 2011
 *
 */
public class Open_Preferences_XML implements PlugIn{
	
	
	public void run(String arg) {
		
	//ask for output path
		OpenDialog fileDialog;
		String fileName;
		String filePath;
		String eName;
		String eValue;
		String defaultFile=Prefs.get("user.xmlpref.file", "myfile.xml");
		fileDialog=new OpenDialog("Select input file",defaultFile,defaultFile);
		fileName=fileDialog.getFileName();
		filePath=fileDialog.getDirectory();
		if (fileName==null)
			{
			IJ.error("No file selected.");
			return ;	
			}
		//IJ.log(filePath+fileName);
    try{
    	
    	File fXmlFile = new File(filePath+fileName);
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
        Document doc = dBuilder.parse(fXmlFile);
        doc.getDocumentElement().normalize();
     
        //IJ.log("Root element :" + doc.getDocumentElement().getNodeName());
        NodeList nList = doc.getElementsByTagName("user");
        //IJ.log("-----------------------");
    	    	
    	int nbelements;
    	//String[] elements={"ROI","Output.path","PixelSize","wavelength","DetectorDistance","QDiv","e","centrex","centrey","qmax","typeofcalcul","alpha_deg"};//new String[nbelements];
    	//nbelements=elements.length;
    	
    	IJ.log(Integer.toString(nList.getLength()));
    	Node nNode = nList.item(0);	   
    	IJ.log(nNode.getNodeName());
    	IJ.log(Short.toString(nNode.getNodeType()));
    	IJ.log(Short.toString(Node.ELEMENT_NODE));
        if (nNode.getNodeType() == Node.ELEMENT_NODE) {
	        	
	        Element eElement = (Element) nNode;
	        
	        /*
	        for (int i=0;i<nbelements;i++){
	        	   IJ.log(elements[i]+ " : " + getTagValue(elements[i],eElement));
	           }
	          */
	        IJ.log("User preferences saved in xml file :");
	        NodeList nlList=eElement.getChildNodes();
	        int ne=nlList.getLength();
	        for (int i=0;i<ne;i++){
	        	eName=nlList.item(i).getNodeName();
	        	eValue=nlList.item(i).getTextContent();
	        	IJ.log(eName +" : "+eValue);
	        	Prefs.set(eName,eValue);
	    		Prefs.savePreferences();
	        }
         }
    } catch (Exception e) {
        e.printStackTrace();
        IJ.log(e.getMessage());
      }
    
     
 }
	 
	
}