
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
 
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
 

import ij.*;
import ij.process.*;
import ij.gui.*;

import java.awt.*;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Vector;

import ij.io.*;
import ij.plugin.PlugIn;
import ij.plugin.filter.*;
import ij.plugin.frame.*;

/**
 * 
 * @author Olivier Tache'  CEA Saclay 2011
 *
 */
public class Save_Preferences_XML implements PlugIn{
	
	
	public void run(String arg) {
		
	//ask for output path
		SaveDialog fileDialog;
		String fileName;
		String filePath;
		String defaultFile=Prefs.get("user.xmlpref.file", "myfile.xml");
		fileDialog=new SaveDialog("Select output file",defaultFile,".xml");
		fileName=fileDialog.getFileName();
		filePath=fileDialog.getDirectory();
		if (fileName==null)
			{
			IJ.error("No file selected.");
			return ;	
			}
		//IJ.log(filePath+fileName);
    try{
    	Prefs.set("user.xmlpref.file",filePath+fileName);
    	int nbelements;
    	String[] elements={"ROI","Output.path","PixelSize","wavelength","DetectorDistance","QDiv","e","centerx","centery","qmax","typeofcalcul","alpha_deg","xmlpref.file"};//new String[nbelements];
    	String itemName;
    	String itemValue;
    	nbelements=elements.length;
    	
    	
    	DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
  	  	DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
   
  	  	//root elements
  	  	Document doc = docBuilder.newDocument();
  	  	Element rootElement = doc.createElement("ImageJprefs");
  	  	doc.appendChild(rootElement);
   
  	  	//staff elements
  	  	Element userpref = doc.createElement("user");
  	  	rootElement.appendChild(userpref);
   
  	  	Element[] elem=new Element[nbelements];
  	  	
    	for (int i=0;i<nbelements;i++){
    		// get parameters from prefs...
    		itemName="user."+elements[i];
    		itemValue=Prefs.get(itemName, "null");
    		//IJ.log("find "+itemName+"-"+itemValue);
    		elem[i]= doc.createElement(itemName);
    		elem[i].appendChild(doc.createTextNode(itemValue));
    		userpref.appendChild(elem[i]);
    		
    	}
      //write the content into xml file
	  TransformerFactory transformerFactory = TransformerFactory.newInstance();
	  Transformer transformer = transformerFactory.newTransformer();
	  DOMSource source = new DOMSource(doc);
	  StreamResult result =  new StreamResult(new File(filePath+fileName));
	  transformer.transform(source, result);
 
	  System.out.println("Done");
	  //IJ.showMessage("Preference Parameters", "Preference parameters saved.");
    }catch(ParserConfigurationException pce){
  	  pce.printStackTrace();
  	  IJ.showMessage("Preference Demo", "ParserConfigurationException");
       }catch(TransformerException tfe){
  	 tfe.printStackTrace();
  	 
  	IJ.showMessage("Preference Demo", tfe.getMessageAndLocation());
       }
    
     
 }
}