import ij.*;
import ij.process.*;
import ij.gui.*;
import ij.io.*;

import java.awt.*;
import java.io.File;
import java.io.FileReader;
import java.math.BigDecimal;
import java.math.MathContext;
import java.util.Vector;
import java.awt.geom.*;
import java.util.*;

import ij.plugin.filter.*;
import ij.plugin.frame.RoiManager;
/**
 * plugin qui permet  l'tilisateur de determiner manulement les maise a l'echelle a faire
 * @author gilles courbatieu
 *
 */
public class Scale_ implements PlugInFilter , DialogListener{
	ImagePlus imp;
	ImageProcessor IPro;
	double exy=1,alpha=0;//e: rapport petit axe/grand axe. alpha: angle d'oriantation du grand axe l'llipse
	GenericDialog gd,gd2;//boite de dialogue standard
	int xC,yC;
	Point Centre=new Point();
	double ay=0,ax=0,q=0,L=0,pixDim=0;
	String loading=new String();
	OvalRoi oval;
	Line lineax,lineay;
	int noe=1;


	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_ALL;
	}

	public void run(ImageProcessor ip) {
		ip.snapshot();
		pixDim=(imp.getOriginalFileInfo()).pixelHeight;
		IPro=ip;
		loadPrefs();
		if(GUIscale()){
			save();
		}
		IPro.reset();
		IJ.freeMemory();
	}
	/************************************************************************
	 * fonction premetant a l'utilisateur de saisir les angles de decalage sur oX et oY
	 * @return vrai si saisie reussit, faux sinon
	 ************************************************************************/
	boolean GUIscale()
	{
		IJ.freeMemory();
		double d1=0,d2=0,theta=0,tmp1,tmp2;
		gd = new GenericDialog("Ellipse parameters...");
		gd.addMessage("Center :");
		gd.addNumericField("x :",xC,0);
		gd.addNumericField("y :",yC,0);
		gd.addMessage("Radius :");
		gd.addNumericField("x radius :",ax*pixDim,0);
		gd.addNumericField(" (x/y) :",exy,3);
		gd.addNumericField("nb of ellipses : ",noe,0);
		gd.addDialogListener(this);
		//gd.addMessage("Position :");
		//gd.addNumericField("Longeur d'onde("+IJ.angstromSymbol+") :",L,4);
		//gd.addNumericField("Distance ("+IJ.angstromSymbol+"-1) :",q,4);

		gd.showDialog();
		if(!gd.wasCanceled())
			{
				xC=(int)gd.getNextNumber();
				yC=(int)gd.getNextNumber();
				ax=gd.getNextNumber()/pixDim;
				exy=gd.getNextNumber();
				//L=gd.getNextNumber();
				//q=gd.getNextNumber();
				if(exy<=0||ax<=0||xC<0||xC>imp.getWidth()||yC<0||yC>imp.getHeight()){
					IJ.error("Invalid values.");
					IJ.freeMemory();
					return GUIscale();
				}
				ay=ax/exy;
				Draw(xC,yC,(int)ax,(int)ay,noe);
				
			return true;	
			}
		else {
			// delete ellipse
			ImageCanvas ic = imp.getCanvas();
			if (ic!=null) ic.setDisplayList(null);
		}
		
		return false;
	}
	
	public boolean dialogItemChanged(GenericDialog gd, AWTEvent e) {
		xC=(int)gd.getNextNumber();
		yC=(int)gd.getNextNumber();
		ax=gd.getNextNumber()/pixDim;
		exy=gd.getNextNumber();
		noe=(int)gd.getNextNumber();
		if(exy<=0||ax<=0||xC<0||xC>imp.getWidth()||yC<0||yC>imp.getHeight()){
			//IJ.error("Erreur !! valeur(s) invalide(s).");
			//IJ.freeMemory();
			return true;
		}
		ay=ax/exy;
		Draw(xC,yC,(int)ax,(int)ay,noe);
		return true;
		
	}
	
	/************************************************************************
	 * fonction qui calcule la distance entre 2 point en dimansion metrique e.g centimetre
	 * @param a coordnnes du 1er point
	 * @param b coordnnes du 1er point
	 * @return nombre representant la distance entre les 2 point
	 *************************************************************************/
	double distance(double a,double b){
		double res=Math.abs(a*pixDim-b*pixDim);
		return res;
	}
	/************************************************************************
	 * fonction qui se charge de dessin un ellipse appres lui avoir applique une rotation
	 * @axram x coordonnes du centre de l'ellipse
	 * @axram y
	 * @axram w largeur
	 * @axram h hauteur
	 ************************************************************************/
	void Draw(int x,int y,int w,int h,int n){
		int w2,h2;
		GeneralPath path = new GeneralPath();
		IPro.reset();//reinitialisation de l'image
		// trace de la croix du centre
		int width = imp.getWidth();
		int height = imp.getHeight();
		path.moveTo(x, 1);
		path.lineTo(x, height);
		path.moveTo(1, y);
		path.lineTo(width, y);
		//trace de l'ellipse
		for(int i=1;i<=n;i++){
			//IJ.log("n:"+n);
			w2=w*i;
			h2=h*i;
			path.append(new Ellipse2D.Float(x-w2/2, y-h2/2, w2, h2), false);
			ImageCanvas ic = imp.getCanvas();
			if (ic==null) return;
			if (path==null)
				ic.setDisplayList(null);
			else
				ic.setDisplayList(path, Color.red, null);
		
		}
	}
	/************************************************************************
	 * fonction qui sauve les axramtres de l'llipse dans le fichier de prf
	 * forme du sauveayrd : a;e;ax;ay;
	 * @return vrai si reussi faux sino
	 ************************************************************************/
	boolean save(){
		String Err= Prefs.load(this, IJ.getApplet());
		if(Err!=null){
			IJ.error("probleme de sauvegarde des donnes !");
			return false;
		}
		//Prefs.set("user.Scale", exy);
		Prefs.set("user.centerx",xC);
		Prefs.set("user.centery",yC);
		Prefs.set("user.e",exy);
		Prefs.set("user.radius",ax);
		//IJ.log("radius : "+ax);
		Prefs.savePreferences();
		return true;
	}
	
	/************************************************************************
	 * fonction qui charge les informations des prefs
	 * @return vrai si reussite faux sinon
	 * OT le 13-06-08
	 ************************************************************************/
	synchronized boolean loadPrefs(){
		exy=(float)Prefs.get("user.e",1);
		xC=(int)Prefs.get("user.centerx",1);
		yC=(int)Prefs.get("user.centery",1);
		ax=(int)Prefs.get("user.radius",1);
		return true;
		
	}
	
	
	
}
